Source11: find-requires
Source12: find-requires.ksyms
%define   kmodtool bash /usr/lib/rpm/redhat/kmodtool

%define kmod_name kvm

# if kversion isn't defined on rpm build line, build against current kernel
%{!?kversion: %define kversion $(uname -r)}

# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.18-8.el5"

%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""

%ifarch i686 x86_64 ia64
%define xenvar xen
%endif

%ifarch i686
%define paevar PAE
%endif

%ifarch ppc64 ppc64iseries
%define kdumpvar kdump
%endif

%ifarch sparc64 ppc
%define smpvar smp
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?paevar} %{?kdumpvar}}

# hint: this can he overridden with "--define kvariants foo bar" on the rpmbuild command line, e.g.
# --define 'kvariants "" smp' 

Name:		%{kmod_name}-kmod
Version:	85
Release:	1%{?dist}
Summary:	Kernel-based Virtual Machine module
Group:		System Environment/Kernel
License:	GPL
URL:		http://kvm.sf.net
Source:		http://download.sourceforge.net/sourceforge/kvm/%{kmod_name}-%{version}.tar.gz
#Patch0:		kvm-bootmenu.patch
Patch1:		kvm-85-e1000-default.patch 
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	redhat-rpm-config

%description
KVM (for Kernel-based Virtual Machine) is a full virtualization solution 
for Linux on x86 hardware. 

Using KVM, one can run multiple virtual machines running unmodified Linux 
or Windows images. Each virtual machine has private virtualized hardware: 
a network card, disk, graphics adapter, etc.

This package contains the KVM module.

# Override find_provides to use a script that provides "kernel(symbol) = hash".
# Pass path of the RPM temp dir containing kabideps to find-provides script.
%global _use_internal_dependency_generator 0
%define __find_requires %_sourcedir/find-requires %{name}

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
pushd %{kmod_name}-%{version}
#%patch0 -p1
%patch1 -p1
popd
for kvariant in %{kvariants} ; do
	cp -a %{kmod_name}-%{version} _kmod_build_${kvariant}
done

%build
for kvariant in %{kvariants}; do
	pushd _kmod_build_${kvariant}
		ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
		./configure --prefix=%{_prefix}
		make %{?_smp_mflags} -C kernel
	popd
done

%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}; do
	ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
	pushd _kmod_build_$kvariant
		#make -C kernel DESTDIR=$RPM_BUILD_ROOT install
		mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant:+-$kvariant}/extra/%{kmod_name}
		ARCH=`uname -m|sed -e "s,i.86,x86," -e "s,x86_64,x86," -e "s,s390x,s390,"`; \
	        install -m 755 kernel/$ARCH/*.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant:+-$kvariant}/extra/%{kmod_name}
	popd
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Apr 21 2009 Levente Farkas <lfarkas@lfarkas.org> - 85-1
- update to kvm-85

* Mon Dec  8 2008 Levente Farkas <lfarkas@lfarkas.org> - 80-1
- update to kvm-80
- rebase to centos weak-updates

* Fri Aug 22 2008 Levente Farkas <lfarkas@lfarkas.org> - 73-1
- update to kvm-73
- rebase to rpmfusion style kmodtool

* Mon Jul 14 2008 Levente Farkas <lfarkas@lfarkas.org> - 71-1
- update to kvm-71

* Thu Sep 13 2007 Daniel de Kok <daniel@centos.org> 36-2
- Predefine kernel version, rather than looking at 'uname -r'.

* Sat Sep 06 2007 Daniel de Kok <daniel@centos.org> 36-1
- Update to KVM-36

* Mon Aug 20 2007 Daniel de Kok <daniel@centos.org> 35-1
- Update to KVM-35

* Wed Jul 28 2007 Daniel de Kok <daniel@centos.org> 33-1
- Update to KVM-33

* Wed Jul 18 2007 Daniel de Kok <daniel@centos.org> 29-1
- Update to KVM-29

* Mon Jun 18 2007 Daniel de Kok <daniel@centos.org> - 28-1
- First kvm kmod spec file. 
